# Class VulkanBufferCopy.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanBufferCopy.Builder

Enclosing class:
  `VulkanBufferCopy`

public static final class VulkanBufferCopy.Builder extends Object
Builds instances of type `VulkanBufferCopy`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanBufferCopy`
  `build()`
  Builds a new `VulkanBufferCopy`.
  `final VulkanBufferCopy.Builder`
  `from(VulkanBufferCopyType instance)`
  Fill a builder with attribute values from the provided `VulkanBufferCopyType` instance.
  `final VulkanBufferCopy.Builder`
  `setSize(long size)`
  Initializes the value for the `size` attribute.
  `final VulkanBufferCopy.Builder`
  `setSourceOffset(long sourceOffset)`
  Initializes the value for the `sourceOffset` attribute.
  `final VulkanBufferCopy.Builder`
  `setTargetOffset(long targetOffset)`
  Initializes the value for the `targetOffset` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanBufferCopy.Builder from(VulkanBufferCopyType instance)
    Fill a builder with attribute values from the provided `VulkanBufferCopyType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setSourceOffset

    public final VulkanBufferCopy.Builder setSourceOffset(long sourceOffset)
    Initializes the value for the `sourceOffset` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `sourceOffset`.

    Parameters:
      `sourceOffset` - The value for sourceOffset
    Returns:
      `this` builder for use in a chained invocation

  - ### setTargetOffset

    public final VulkanBufferCopy.Builder setTargetOffset(long targetOffset)
    Initializes the value for the `targetOffset` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `targetOffset`.

    Parameters:
      `targetOffset` - The value for targetOffset
    Returns:
      `this` builder for use in a chained invocation

  - ### setSize

    public final VulkanBufferCopy.Builder setSize(long size)
    Initializes the value for the `size` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `size`.

    Parameters:
      `size` - The value for size
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanBufferCopy build()
    Builds a new `VulkanBufferCopy`.
    Returns:
      An immutable instance of VulkanBufferCopy
    Throws:
      `IllegalStateException` - if any required attributes are missing